class gauges_goose_4 extends TemplateElement {
    constructor() {
        super();
        this.location = "interior";
        this.curTime = 0.0;
        this.bNeedUpdate = false;
        this._isConnected = false;
    }
    get templateID() { return "gauges_goose_4"; }
    connectedCallback() {
        super.connectedCallback();
        let parsedUrl = new URL(this.getAttribute("Url").toLowerCase());
        let updateLoop = () => {
            if (!this._isConnected)
                return;
            this.Update();
            requestAnimationFrame(updateLoop);
        };
        this._isConnected = true;
        requestAnimationFrame(updateLoop);
    }
    disconnectedCallback() {
    }
    Update() {
		this.updateInstruments();
    }
    /*playInstrumentSound(soundId) {
        if (this.isElectricityAvailable()) {
            Coherent.call("PLAY_INSTRUMENT_SOUND", soundId);
            return true;
        }
        return false;
    }	*/
    updateInstruments() {

       // TAXI LIGHTS CONTROL
       if (SimVar.GetSimVarValue("IS GEAR RETRACTABLE", "Boolean")) {
         var gears_extracted = SimVar.GetSimVarValue("GEAR HANDLE POSITION", "Boolean");
         if (SimVar.GetSimVarValue("LIGHT TAXI", "bool") && !gears_extracted)
            SimVar.SetSimVarValue("K:TOGGLE_TAXI_LIGHTS", "bool", false)
         else if (!SimVar.GetSimVarValue("LIGHT TAXI", "bool") && gears_extracted)
            SimVar.SetSimVarValue("K:TOGGLE_TAXI_LIGHTS", "bool", true)
       }


		/* HSI_HSI_COMPASS_RING_0 */
		var hsi_hsi_compass_ring_0 = this.querySelector("#hsi_hsi_compass_ring_0");
		if (typeof hsi_hsi_compass_ring_0 !== "undefined") {
		  var transform = '';

		  {

			var ExpressionResult = ((SimVar.GetSimVarValue("PLANE HEADING DEGREES TRUE", "degrees")) * (-1))* Math.PI/180; /* PARSED FROM "(A:Plane heading degrees gyro,degrees) /-/ dgrd" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 0;
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  if (transform != '')
		    hsi_hsi_compass_ring_0.style.transform = transform; 

		}

		/* HSI_HSI_HEADING_BUG_1 */
		var hsi_hsi_heading_bug_1 = this.querySelector("#hsi_hsi_heading_bug_1");
		if (typeof hsi_hsi_heading_bug_1 !== "undefined") {
		  var transform = '';

		  {

			var ExpressionResult = (SimVar.GetSimVarValue("AUTOPILOT HEADING LOCK DIR", "degrees") - SimVar.GetSimVarValue("PLANE HEADING DEGREES TRUE", "degrees"))* Math.PI/180; /* PARSED FROM " (A:Autopilot heading lock dir,degrees) (A:Plane heading degrees gyro,degrees) - dgrd " */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 0;
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  if (transform != '')
		    hsi_hsi_heading_bug_1.style.transform = transform; 

		}

		/* HSI_HSI_COURSE_DEVIATION_SCALE_2 */
		var hsi_hsi_course_deviation_scale_2 = this.querySelector("#hsi_hsi_course_deviation_scale_2");
		if (typeof hsi_hsi_course_deviation_scale_2 !== "undefined") {
		  var transform = '';

		  {

			var ExpressionResult = (SimVar.GetSimVarValue("NAV OBS:1", "degrees") - SimVar.GetSimVarValue("PLANE HEADING DEGREES TRUE", "degrees") - 90)* Math.PI/180; /* PARSED FROM "(A:NAV1 OBS,degrees) (A:Plane heading degrees gyro,degrees) 90 - - dgrd" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 0;
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  if (transform != '')
		    hsi_hsi_course_deviation_scale_2.style.transform = transform; 

		}

		/* HSI_HSI_NAV_FLAG_3 */
		var hsi_hsi_nav_flag_3 = this.querySelector("#hsi_hsi_nav_flag_3");
		if (typeof hsi_hsi_nav_flag_3 !== "undefined") {
		  var transform = '';

		  hsi_hsi_nav_flag_3.style.display = !(SimVar.GetSimVarValue("HSI CDI NEEDLE VALID:1", "boolean")) + 1 + 1 + 1 ? "block" : "none";

		  if (transform != '')
		    hsi_hsi_nav_flag_3.style.transform = transform; 

		}

		/* HSI_HSI_HDG_FLAG_4 */
		var hsi_hsi_hdg_flag_4 = this.querySelector("#hsi_hsi_hdg_flag_4");
		if (typeof hsi_hsi_hdg_flag_4 !== "undefined") {
		  var transform = '';

		  hsi_hsi_hdg_flag_4.style.display = 1 + 1 + 1 ? "block" : "none";

		  if (transform != '')
		    hsi_hsi_hdg_flag_4.style.transform = transform; 

		}

		/* HSI_HSI_GLIDESLOPE_DEFLECTION_5 */
		var hsi_hsi_glideslope_deflection_5 = this.querySelector("#hsi_hsi_glideslope_deflection_5");
		if (typeof hsi_hsi_glideslope_deflection_5 !== "undefined") {
		  var transform = '';

		  {
			var ExpressionResult = SimVar.GetSimVarValue("NAV GSI:1", "percent") / 250; /* PARSED FROM "(A:NAV GSI:1,percent) 250 /" */
			var Minimum = -50.000;
			ExpressionResult = Math.max(ExpressionResult, Minimum);
			var Maximum = 40.000;
			ExpressionResult = Math.min(ExpressionResult, Maximum);
			transform += 'translate(' + (ExpressionResult * 0) + 'px, ' + (ExpressionResult * 0.5) + 'px) ';
		  }
		  if (transform != '')
		    hsi_hsi_glideslope_deflection_5.style.transform = transform; 

		}

		/* HSI_HSI_TO_ARROW_6 */
		var hsi_hsi_to_arrow_6 = this.querySelector("#hsi_hsi_to_arrow_6");
		if (typeof hsi_hsi_to_arrow_6 !== "undefined") {
		  var transform = '';

		  hsi_hsi_to_arrow_6.style.display = ( SimVar.GetSimVarValue("HSI TF FLAGS", "enum") == 1 ) ? "block" : "none";

		  {

			var ExpressionResult = (( ( ( 1 || 1 ) == 0 ) ?  SimVar.GetSimVarValue("NAV OBS:1", "degrees") - SimVar.GetSimVarValue("PLANE HEADING DEGREES TRUE", "degrees") + 90 : 0 ))* Math.PI/180; /* PARSED FROM "(A:NAV1 OBS,degrees) d (A:PARTIAL PANEL HEADING,bool) (A:PARTIAL PANEL ELECTRICAL,bool) or 0 == if{ (A:Plane heading degrees gyro,degrees) - 90 + } dgrd" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 90;
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  if (transform != '')
		    hsi_hsi_to_arrow_6.style.transform = transform; 

		}

		/* HSI_HSI_FROM_ARROW_7 */
		var hsi_hsi_from_arrow_7 = this.querySelector("#hsi_hsi_from_arrow_7");
		if (typeof hsi_hsi_from_arrow_7 !== "undefined") {
		  var transform = '';

		  hsi_hsi_from_arrow_7.style.display = ( SimVar.GetSimVarValue("HSI TF FLAGS", "enum") == 2 ) ? "block" : "none";

		  {

			var ExpressionResult = (( ( ( 1 || 1 ) == 0 ) ?  SimVar.GetSimVarValue("NAV OBS:1", "degrees") - SimVar.GetSimVarValue("PLANE HEADING DEGREES TRUE", "degrees") + 90 : 0 ))* Math.PI/180; /* PARSED FROM "(A:NAV1 OBS,degrees) d (A:PARTIAL PANEL HEADING,bool) (A:PARTIAL PANEL ELECTRICAL,bool) or 0 == if{ (A:Plane heading degrees gyro,degrees) - 90 + } dgrd" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = (-90);
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  if (transform != '')
		    hsi_hsi_from_arrow_7.style.transform = transform; 

		}

		/* HSI_HSI_COURSE_ARROW_8 */
		var hsi_hsi_course_arrow_8 = this.querySelector("#hsi_hsi_course_arrow_8");
		if (typeof hsi_hsi_course_arrow_8 !== "undefined") {
		  var transform = '';

		  {

			var ExpressionResult = (SimVar.GetSimVarValue("NAV OBS:1", "degrees") - SimVar.GetSimVarValue("PLANE HEADING DEGREES TRUE", "degrees") - 90)* Math.PI/180; /* PARSED FROM "(A:NAV1 OBS,degrees) (A:Plane heading degrees gyro,degrees) 90 - - dgrd" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 0;
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  if (transform != '')
		    hsi_hsi_course_arrow_8.style.transform = transform; 

		}

		/* HSI_HSI_COURSE_DEFLECTION_9 */
		var hsi_hsi_course_deflection_9 = this.querySelector("#hsi_hsi_course_deflection_9");
		if (typeof hsi_hsi_course_deflection_9 !== "undefined") {
		  var transform = '';

		  hsi_hsi_course_deflection_9.style.display = !(SimVar.GetSimVarValue("GPS DRIVES NAV1", "boolean")) ? "block" : "none";

		  {

			var ExpressionResult = (SimVar.GetSimVarValue("NAV OBS:1", "degrees") - SimVar.GetSimVarValue("PLANE HEADING DEGREES TRUE", "degrees") - 90)* Math.PI/180; /* PARSED FROM "(A:NAV1 OBS,degrees) (A:Plane heading degrees gyro,degrees) 90 - - dgrd" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 0;
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  {
			var ExpressionResult = SimVar.GetSimVarValue("NAV CDI:1", "percent") / -300; /* PARSED FROM "(A:NAV CDI:1,percent) -300 /" */
			var Minimum = -60.000;
			ExpressionResult = Math.max(ExpressionResult, Minimum);
			var Maximum = 60.000;
			ExpressionResult = Math.min(ExpressionResult, Maximum);
			transform += 'translate(' + (ExpressionResult * 0) + 'px, ' + (ExpressionResult * 0.5) + 'px) ';
		  }
		  if (transform != '')
		    hsi_hsi_course_deflection_9.style.transform = transform; 

		}

		/* HSI_HSI_COURSE_DEFLECTION_10 */
		var hsi_hsi_course_deflection_10 = this.querySelector("#hsi_hsi_course_deflection_10");
		if (typeof hsi_hsi_course_deflection_10 !== "undefined") {
		  var transform = '';

		  hsi_hsi_course_deflection_10.style.display = SimVar.GetSimVarValue("GPS DRIVES NAV1", "boolean") ? "block" : "none";

		  {

			var ExpressionResult = (( ( ( 1 || 1 ) == 0 ) ?  SimVar.GetSimVarValue("NAV OBS:1", "degrees") - SimVar.GetSimVarValue("PLANE HEADING DEGREES TRUE", "degrees") - 90 : 0 ))* Math.PI/180; /* PARSED FROM "(A:NAV1 OBS,degrees) d (A:PARTIAL PANEL HEADING,bool) (A:PARTIAL PANEL ELECTRICAL,bool) or 0 == if{ (A:Plane heading degrees gyro,degrees) 90 - - } dgrd" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 0;
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  {
			var ExpressionResult = SimVar.GetSimVarValue("GPS WP CROSS TRK", "nautical miles") * -4; /* PARSED FROM "(A:GPS WP CROSS TRK,nmiles) -4 *" */
			var Minimum = -23.000;
			ExpressionResult = Math.max(ExpressionResult, Minimum);
			var Maximum = 23.000;
			ExpressionResult = Math.min(ExpressionResult, Maximum);
			transform += 'translate(' + (ExpressionResult * 0) + 'px, ' + (ExpressionResult * 1) + 'px) ';
		  }
		  if (transform != '')
		    hsi_hsi_course_deflection_10.style.transform = transform; 

		}

		/* HSI_HSI_HEADING_LUBBER_11 */
		var hsi_hsi_heading_lubber_11 = this.querySelector("#hsi_hsi_heading_lubber_11");
		if (typeof hsi_hsi_heading_lubber_11 !== "undefined") {
		  var transform = '';

		  if (transform != '')
		    hsi_hsi_heading_lubber_11.style.transform = transform; 

		}

		/* HSI_HSI_REFLECTION_12 */
		var hsi_hsi_reflection_12 = this.querySelector("#hsi_hsi_reflection_12");
		if (typeof hsi_hsi_reflection_12 !== "undefined") {
		  var transform = '';

		  if (transform != '')
		    hsi_hsi_reflection_12.style.transform = transform; 

		}

		/* HSI_HSI_KNOB_COURSE_13 */
		var hsi_hsi_knob_course_13 = this.querySelector("#hsi_hsi_knob_course_13");
		if (typeof hsi_hsi_knob_course_13 !== "undefined") {
		  var transform = '';

		  {

			var ExpressionResult = (SimVar.GetSimVarValue("NAV OBS:1", "degrees") - SimVar.GetSimVarValue("PLANE HEADING DEGREES TRUE", "degrees") - 90)* Math.PI/180; /* PARSED FROM "(A:NAV1 OBS,degrees) d (A:Plane heading degrees gyro,degrees) 90 - - dgrd" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 0;
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  if (transform != '')
		    hsi_hsi_knob_course_13.style.transform = transform; 

		}

		/* HSI_HSI_KNOB_HEADING_14 */
		var hsi_hsi_knob_heading_14 = this.querySelector("#hsi_hsi_knob_heading_14");
		if (typeof hsi_hsi_knob_heading_14 !== "undefined") {
		  var transform = '';

		  {

			var ExpressionResult = (SimVar.GetSimVarValue("AUTOPILOT HEADING LOCK DIR", "degrees") - SimVar.GetSimVarValue("PLANE HEADING DEGREES TRUE", "degrees") + 90)* Math.PI/180; /* PARSED FROM "(A:Autopilot heading lock dir,degrees) d (A:Plane heading degrees gyro,degrees) 90 + - dgrd" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 0;
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  if (transform != '')
		    hsi_hsi_knob_heading_14.style.transform = transform; 

		}

		/* TRIM_POPUPS_RUDDER_TRIM_WHEEL_0 */
		var trim_popups_rudder_trim_wheel_0 = this.querySelector("#trim_popups_rudder_trim_wheel_0");
		if (typeof trim_popups_rudder_trim_wheel_0 !== "undefined") {
		  var transform = '';

		  {

			var ExpressionResult = SimVar.GetSimVarValue("RUDDER TRIM PCT", "percent") / 40 + Math.PI; /* PARSED FROM "(A:RUDDER TRIM PCT, percent) 40 / pi +" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 0;
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  if (transform != '')
		    trim_popups_rudder_trim_wheel_0.style.transform = transform; 

		}

		/* TRIM_POPUPS_TRIM_WHEEL_STRIP_1 */
		var trim_popups_trim_wheel_strip_1 = this.querySelector("#trim_popups_trim_wheel_strip_1");
		if (typeof trim_popups_trim_wheel_strip_1 !== "undefined") {
		  var transform = '';

		  {
			var ExpressionResult = -121 + SimVar.GetSimVarValue("ELEVATOR TRIM PCT", "percent") * 6; /* PARSED FROM "-121 (A:ELEVATOR TRIM POSITION, degrees) 6 * +" */
			var Minimum = -350.000;
			ExpressionResult = Math.max(ExpressionResult, Minimum);
			var Maximum = 0.000;
			ExpressionResult = Math.min(ExpressionResult, Maximum);
			transform += 'translate(' + (ExpressionResult * 0) + 'px, ' + (ExpressionResult * 1) + 'px) ';
		  }
		  if (transform != '')
		    trim_popups_trim_wheel_strip_1.style.transform = transform; 

		}

		/* TRIM_POPUPS_TRIM_SHADOW_2 */
		var trim_popups_trim_shadow_2 = this.querySelector("#trim_popups_trim_shadow_2");
		if (typeof trim_popups_trim_shadow_2 !== "undefined") {
		  var transform = '';

		  if (transform != '')
		    trim_popups_trim_shadow_2.style.transform = transform; 

		}

		/* TRIM_POPUPS_TRIM_HIGHLIGHT_3 */
		var trim_popups_trim_highlight_3 = this.querySelector("#trim_popups_trim_highlight_3");
		if (typeof trim_popups_trim_highlight_3 !== "undefined") {
		  var transform = '';

		  if (transform != '')
		    trim_popups_trim_highlight_3.style.transform = transform; 

		}

    }
}
registerLivery("gauges_goose_4-element", gauges_goose_4);
